Flatland 2.0 Introduction
=========================

## What's new?

In this version of **Flat**land, we are moving closer to realistic and more complex railway problems. 
Earlier versions of **Flat**land introduced you to the concept of restricted transitions, but they were still too simplistic to give us feasible solutions for daily operations. 
Thus the following changes are coming in the next version to be closer to real railway network challenges:

- **New Level Generator** provide less connections between different nodes in the network and thus agent densities on rails are much higher.
- **Stochastic Events** cause agents to stop and get stuck for different numbers of time steps.
- **Different Speed Classes** allow agents to move at different speeds and thus enhance complexity in the search for optimal solutions.


We explain these changes in more detail and how you can play with their parametrization in Tutorials 3--5:
* [Tutorials](https://gitlab.aicrowd.com/flatland/flatland/tree/master/docs/tutorials)

We appreciate *your feedback* on the performance and the difficulty on these levels to help us shape the best possible **Flat**land 2.0 environment.

## Example code

To see all the changes in action you can just run the 
* [examples/flatland_example_2_0.py](https://gitlab.aicrowd.com/flatland/flatland/blob/master/examples/flatland_2_0_example.py) 

example.
